<?php

/******************************************************************************************
 * Copyright (C) Smackcoders. - All Rights Reserved under Smackcoders Proprietary License
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 * You can contact Smackcoders at email address info@smackcoders.com.
 *******************************************************************************************/

namespace Smackcoders\CFCSV;

if (!defined('ABSPATH'))
	exit; // Exit if accessed directly

class CoreFieldsImport
{
	private static $core_instance = null, $media_instance, $nextgen_instance,$mappingInstance;
	public $detailed_log;
	public $generated_content;

	public $media_log,$failed_media_data;
	public $openAI_response=array();
	public static $failed_images_instance;

	public static function getInstance()
	{
		if (CoreFieldsImport::$core_instance == null) {
			CoreFieldsImport::$core_instance = new CoreFieldsImport;
			CoreFieldsImport::$failed_images_instance = new FailedImagesUpdate();
			CoreFieldsImport::$media_instance = new MediaHandling;
			CoreFieldsImport::$mappingInstance = new MappingExtension;
			CoreFieldsImport::$nextgen_instance = new NextGenGalleryImport;
			return CoreFieldsImport::$core_instance;
		}
		return CoreFieldsImport::$core_instance;
	}
	function set_core_values($header_array, $value_array, $map, $type, $mode, $line_number , $unmatched_row, $check ,$hash_key ,$acf, $pods, $toolset, $jetengine,$jetengine_cpt, $metabox, $update_based_on, $gmode, $templatekey, $poly_array = null,$media_meta = null,$media_type = null,$post_cat_list = null,$isCategory = null,$categoryList = null)		
	{
		//$type = 'Media';
		//$media_type = 'Local';
		global $wpdb;
		$map = $this->filterNumKeys($map);
		$map=$this->replaceValues($map);
		$post_id = null;
		$helpers_instance = ImportHelpers::getInstance();
		CoreFieldsImport::$media_instance->header_array = $header_array;
		CoreFieldsImport::$media_instance->value_array = $value_array;
		$learnpress_instance = LearnPressImport::getInstance();
		$customer_reviews_instance = CustomerReviewsImport::getInstance();
		$log_table_name = $wpdb->prefix . "cfimport_detail_log";
		$media_handle = get_option('smack_image_options');
		$unikey_name = 'hash_key';
		$unikey_value = $hash_key;

		if ($gmode == 'CLI') { //Exchange the hashkey value with template key
			$unikey_name = 'templatekey';
			$unikey_value = ($templatekey != null) ? $templatekey : '';
		}

		$updated_row_counts = $helpers_instance->update_count($unikey_value, $unikey_name);
		$created_count = $updated_row_counts['created'];
		$updated_count = $updated_row_counts['updated'];
		$skipped_count = $updated_row_counts['skipped'];

		$taxonomies = get_taxonomies();
		if (in_array($type, $taxonomies)) {
			$import_type = $type;
			if ($import_type == 'category' || $import_type == 'product_category' || $import_type == 'product_cat' || $import_type == 'wpsc_product_category') :
				$type = 'Categories';
			elseif ($import_type == 'product_tag' || $import_type == 'event-tags' || $import_type == 'post_tag') :
				$type = 'Tags';

			else :
				$type = 'Taxonomies';
			endif;
		}
		if($type == 'elementor_library'){
			$elementor_import=new ElementorImport;
			$elementor_import->set_elementor_values($header_array ,$value_array , $map, $post_id , $type, $mode, $line_number , $hash_key);
			wp_die();
		}
		if(!empty($media_meta)){
			if (isset($media_handle['media_settings'])) {
				$post_values = $helpers_instance->get_header_values($media_meta , $header_array , $value_array);
				$media_handle['media_settings']['title'] = isset($post_values['featured_image_title']) ? $post_values['featured_image_title'] : '';
    			$media_handle['media_settings']['caption'] = isset($post_values['featured_image_caption']) ? $post_values['featured_image_caption'] : '';
    			$media_handle['media_settings']['alttext'] = isset($post_values['featured_image_alt_text']) ? $post_values['featured_image_alt_text'] : '';
    			$media_handle['media_settings']['description'] = isset($post_values['featured_image_description']) ? $post_values['featured_image_description'] : '';
				$media_handle['media_settings']['file_name'] = isset($post_values['featured_file_name']) ? $post_values['featured_file_name'] : '';
				update_option('smack_image_options', $media_handle);
			}
		}
		$poly_values = $helpers_instance->get_header_values($poly_array,$header_array,$value_array);
		if (($type == 'Categories') || ($type == 'Tags') || ($type == 'Taxonomies') || ($type == 'Comments') || ($type == 'Users') || ($type == 'Customer Reviews') || ($type == 'nav_menu_item') || ($type == 'widgets') || ($type == 'Media')) {
			$taxonomies_instance = TaxonomiesImport::getInstance();
			$comments_instance = CommentsImport::getInstance();
			$users_instance = UsersImport::getInstance();
			$media_core_instance = MediaImport::getInstance();
			$post_values = [];
			$post_values = $helpers_instance->get_header_values($map, $header_array, $value_array);

			if (($type == 'Categories') || ($type == 'Tags') || ($type == 'Taxonomies')) {
				$result = $taxonomies_instance->taxonomies_import_function($post_values, $mode, $import_type, $unmatched_row, $check, $hash_key, $line_number, $header_array, $value_array, $gmode, $templatekey,$poly_values);
			}
			if($type == 'Media'){
				$media_type = ucfirst($media_type);
				$result = $media_core_instance->media_fields_import($post_values , $mode , $type , $media_type ,$unikey_value ,$unikey_name, $line_number,$hash_key,$header_array ,$value_array);
			}
			if ($type == 'Users') {
				$result = $users_instance->users_import_function($post_values, $mode, $unikey_value, $unikey_name, $line_number,$check);
			}
			if ($type == 'Comments') {
				$result = $comments_instance->comments_import_function($post_values, $mode, $unikey_value, $unikey_name, $line_number);
			}
			if ($type == 'nav_menu_item') {
				$comments_instance->menu_import_function($post_values, $mode, $unikey_value, $unikey_name, $line_number);
			}
			if ($type == 'widgets') {
				$comments_instance->widget_import_function($post_values, $mode, $unikey_value, $unikey_name, $line_number);
			}
			if ($type == 'lp_order') {
				$result = $learnpress_instance->learnpress_orders_import($post_values, $mode, $check, $unikey_value, $unikey_name, $line_number);
			}
			if ($type == 'Customer Reviews') {
				$result = $customer_reviews_instance->customer_reviews_import($post_values, $mode, $check, $unikey_value, $unikey_name, $line_number);
			}


			$post_id = isset($result['ID']) ? $result['ID'] : '';
			if ($gmode != 'CLI')
				$helpers_instance->get_post_ids($post_id, $hash_key);

			if (isset($post_values['featured_image'])) {
				if (!empty($post_id) && !is_plugin_active('featured-image-from-url/featured-image-from-url.php')) {
					if (strpos($post_values['featured_image'], '|') !== false) {
						$featured_img = explode('|', $post_values['featured_image']);
						$post_values['featured_image'] = $featured_img[0];
					} else if (strpos($post_values['featured_image'], ',') !== false) {
						$feature_img = explode(',', $post_values['featured_image']);
						$post_values['featured_image'] = $feature_img[0];
					} else {
						$featured_image = $post_values['featured_image'];
						$post_values['featured_image'] = $featured_image;
					}
					if (preg_match_all('/\b[-A-Z0-9+&@#\/%=~_|$?!:,.]*[A-Z0-9+&@#\/%=~_|$]/i', $post_values['featured_image'], $matchedlist, PREG_PATTERN_ORDER)) {
						$attach_id = $helpers_instance->featured_image_handling($post_values, $post_id, $type,$import_type, $unikey_value, $unikey_name, $header_array, $value_array, $hash_key, $templatekey,$line_number);
					}
				}
			}

			if (isset($this->detailed_log[$line_number]) && is_array($this->detailed_log[$line_number]) && isset($this->detailed_log[$line_number]['Message'])) {
				if (preg_match("(Can't|Skipped|Duplicate)", $this->detailed_log[$line_number]['Message']) === 0) {
					if ($type == 'Users') {
						$this->detailed_log[$line_number]['webLink'] = get_author_posts_url( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_user_link( $post_id , true );
						$this->detailed_log[$line_number]['post_type'] = 'users';
					$this->detailed_log[$line_number]['id'] = $post_id;
					} 
					elseif( $type == 'Media'){
						if (!empty($post_id)) {
							//$this->detailed_log[$line_number]['mediaData'] = $result['DATA'];
							$this->detailed_log[$line_number]['post_type'] = "Media";
							$this->detailed_log[$line_number]['id'] = $post_id;
							
							$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id , true );
							$image_url = wp_get_attachment_url($post_id);
							$this->detailed_log[$line_number]['webLink'] = $image_url;
							return $post_id;
						}
					}elseif ($type == 'Tags' || $type == 'Categories' || $type == 'Taxonomies' || $type == 'post_tag' || $type == 'Post_category') {
						$post_values['post_title'] = isset($post_values['post_title']) ? $post_values['post_title'] : '';
						//$this->detailed_log[$line_number]['VERIFY'] = "<b> Click here to verify</b> - <a href='" . get_edit_term_link($post_id, $import_type) . "'target='_blank' title='" . esc_attr('Edit this item') . "'>Admin View</a>";
						$this->detailed_log[$line_number]['adminLink'] = get_edit_term_link( $post_id, $import_type );
						$this->detailed_log[$line_number]['post_type'] = $type;
						$term_link = get_term_link($post_id, $import_type);
						if (!is_wp_error($term_link)) {
							$this->detailed_log[$line_number]['webLink'] = $term_link;
						}
					} elseif ($type == 'Comments') {
						$this->detailed_log[$line_number]['webLink'] = get_comment_link( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_comment_link( $post_id );
						$comment = get_comment($post_id);
						$this->detailed_log[$line_number]['id'] = $post_id ;
						$this->detailed_log[$line_number]['post_type'] = 'Comment' ;
						$comment_post_id = isset($comment->comment_post_ID) ? $comment->comment_post_ID : null;
						$post_type = isset($comment_post_id) ? get_post_type($comment_post_id) : null;
						// $this->detailed_log[$line_number]['post_type'] = isset($post_type) ? $post_type : 'Comment';
					} elseif ($type == 'Customer Reviews') {
						$this->detailed_log[$line_number]['webLink'] = get_permalink( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id, true );
						$this->detailed_log[$line_number]['post_type'] = get_post_type($post_id);
						$this->detailed_log[$line_number]['post_title'] = get_the_title($post_id);
					} else {
						$post_values['post_title'] = isset($post_values['post_title']) ? $post_values['post_title'] : '';
						$import_type = isset($import_type) ? $import_type : '';
						$this->detailed_log[$line_number]['webLink'] = get_permalink( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id, true );
						$this->detailed_log[$line_number]['post_type'] = get_post_type($post_id);
						$this->detailed_log[$line_number]['post_title'] = get_the_title($post_id);
					}
					if (isset($post_values['post_status'])) {
						$this->detailed_log[$line_number]['Status'] = $post_values['post_status'];
					}
				}
			}
			return $post_id;
		}

		$optional_type = '';
		if (is_plugin_active('jet-engine/jet-engine.php')) {
			$get_slug_name = $wpdb->get_results("SELECT slug FROM {$wpdb->prefix}jet_post_types WHERE status = 'content-type'");
			foreach ($get_slug_name as $key => $get_slug) {
				$value = $get_slug->slug;
				$optionaltype = $value;
				if ($optionaltype == $type) {
					$optional_type = $optionaltype;
				}
			}
		}

		if ($optional_type == $type) {
			$current_user = wp_get_current_user();
			$author_id = $current_user->data->ID;
			if (empty($author_id)) {
				$author_id = 1;
			}
			if ($mode == 'Insert') {
				$post_values = [];
				$post_values = $helpers_instance->get_header_values($map, $header_array, $value_array);
				$table_name = 'jet_cct_' . $type;
				$value_status =  $post_values['cct_status'];
				$wpdb->get_results("INSERT INTO {$wpdb->prefix}$table_name(cct_status,cct_author_id) values('$value_status', $author_id)");
				$get_result =  $wpdb->get_results($wpdb->prepare("SELECT _ID FROM {$wpdb->prefix}$table_name WHERE  cct_status = '$value_status' order by _ID DESC "));
				$id = $get_result[0];
				$post_id = $id->_ID;

				$page = 'jet-cct-' . $type;
				$dir = site_url() . '/wp-admin';
				$wpdb->get_results("UPDATE $log_table_name SET created = $created_count WHERE $unikey_name = '$unikey_value'");
				$cct_post_title = isset($post_values['post_title']) ? $post_values['post_title'] : '';

				$this->detailed_log[$line_number]['Message'] = 'Inserted Custom Content Type '  . ' ID: ' . $post_id;
				$this->detailed_log[$line_number]['id'] = $post_id;
				$this->detailed_log[$line_number]['state'] = 'Inserted';
				$this->detailed_log[$line_number]['adminLink'] = "$dir/admin.php?page=$page&cct_action=edit&item_id=$post_id";
				$this->detailed_log[$line_number]['webLink'] = get_permalink($post_id);
				$this->detailed_log[$line_number]['status'] = $value_status;
				if($unmatched_row == 'true'){
					global $wpdb;
					$type ='cct';
					$post_entries_table = $wpdb->prefix ."post_entries_table";
					$file_table_name = $wpdb->prefix."smackcf_file_events";
					$get_id  = $wpdb->get_results( "SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");	
					$file_name = $get_id[0]->file_name;
					$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$post_id}','{$type}', '{$file_name}','Inserted')");
				}			
				return $post_id;
			} else {
				if ($check == '_ID') {
					$post_values = [];
					$post_values = $helpers_instance->get_header_values($map, $header_array, $value_array);
					if (!empty($post_values['_ID'])) {
						$page = 'jet-cct-' . $type;
						$dir = site_url() . '/wp-admin';
						$ID = $post_values['_ID'];
						$table_name = 'jet_cct_' . $type;
						$get_result =  $wpdb->get_results("SELECT _ID FROM {$wpdb->prefix}$table_name WHERE _ID = $ID AND cct_status != 'trash' order by _ID DESC ");

						if (!empty($get_result)) {
							if (isset($post_values['cct_status'])) {
								$jet_status =  $post_values['cct_status'];
								$wpdb->update(
									$wpdb->prefix . 'jet_cct_' . $type,
									array(
										'cct_status' => $jet_status,
									),
									array(
										'_ID' => $ID
									)
								);
							}
							$updated_row_counts = $helpers_instance->update_count($unikey_value, $unikey_name);
							$updated_count = $updated_row_counts['updated'];
							$wpdb->get_results("UPDATE $log_table_name SET updated = $updated_count WHERE $unikey_name = '$unikey_value'");
							$status =  $wpdb->get_results("SELECT cct_status FROM {$wpdb->prefix}$table_name WHERE _ID = $ID ");
							$post_stat = $status[0]->cct_status;

							$cct_post_title = isset($post_values['post_title']) ? $post_values['post_title'] : '';

							$this->detailed_log[$line_number]['Message'] = 'Updated Custom Content Type '  . ' ID: ' . $ID;
							$this->detailed_log[$line_number]['id'] = $ID;
							$this->detailed_log[$line_number]['state'] = 'Updated';
							$this->detailed_log[$line_number]['adminLink'] = "$dir/admin.php?page=$page&cct_action=edit&item_id=$ID";
							$this->detailed_log[$line_number]['webLink'] = get_permalink($ID);	
							$this->detailed_log[$line_number][' Status'] = $post_stat;
							if($unmatched_row == 'true'){
								global $wpdb;
								$type ='cct';
								$post_entries_table = $wpdb->prefix ."post_entries_table";
								$file_table_name = $wpdb->prefix."smackcf_file_events";
								$get_id  = $wpdb->get_results( "SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");	
								$file_name = $get_id[0]->file_name;
								$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$ID}','{$type}', '{$file_name}','Inserted')");
							}
							return $ID;
						} else {
							$value_status =  empty($post_values['cct_status']) ? "publish" : $post_values['cct_status'];
							$wpdb->get_results("INSERT INTO {$wpdb->prefix}$table_name(cct_status,cct_author_id) values('$value_status',$author_id)");
							$get_result =  $wpdb->get_results("SELECT _ID FROM {$wpdb->prefix}$table_name WHERE  cct_status = '$value_status' order by _ID DESC ");
							$post_id = $get_result[0]->_ID;
							$wpdb->get_results("UPDATE $log_table_name SET created = $created_count WHERE $unikey_name = '$unikey_value'");
							$cct_post_title = isset($post_values['post_title']) ? $post_values['post_title'] : '';

							$this->detailed_log[$line_number]['Message'] = 'Inserted Custom Content Type '  . ' ID: ' . $post_id;
							//$this->detailed_log[$line_number]['VERIFY'] = "<b> Click here to verify</b> - <a href='$dir/admin.php?page=$page&cct_action=edit&item_id=$post_id' target='_blank' title='" . esc_attr(sprintf(__('View &#8220;%s&#8221;'), $cct_post_title)) . "'rel='permalink'>Admin View</a>";
							$this->detailed_log[$line_number]['id'] = $post_id;
							$this->detailed_log[$line_number]['state'] = 'Inserted';
							$this->detailed_log[$line_number]['adminLink'] = "$dir/admin.php?page=$page&cct_action=edit&item_id=$post_id";
							$this->detailed_log[$line_number]['webLink'] = get_permalink($post_id);		
							$this->detailed_log[$line_number]['status'] = $value_status;
							$this->detailed_log[$line_number][' Status'] = $value_status;
							if($unmatched_row == 'true'){
								global $wpdb;
								$type ='cct';
								$post_entries_table = $wpdb->prefix ."post_entries_table";
								$file_table_name = $wpdb->prefix."smackcf_file_events";
								$get_id  = $wpdb->get_results( "SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");	
								$file_name = $get_id[0]->file_name;
								$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$post_id}','{$type}', '{$file_name}','Inserted')");
							}
							return $post_id;
						}
					} else {
						$this->detailed_log[$line_number]['Message'] = "Skipped.Cannot update.ID's are empty.";
						$this->detailed_log[$line_number]['state'] = 'Skipped';
						$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
					}
				}
			}
		} elseif ($type == 'Images' || $type == 'ngg_pictures') {
			$post_values = [];
			$file_table_name = $wpdb->prefix . "smackcf_file_events";
			$get_id = $wpdb->get_results("SELECT file_name FROM $file_table_name WHERE `hash_key` = '$hash_key'");

			$file_name = $get_id[0]->file_name;
			$file_extension = pathinfo($file_name, PATHINFO_EXTENSION);
			foreach ($map as $key => $value) {
				$csv_value = trim($map[$key]);
				if (!empty($csv_value)) {
					$get_key = array_search($csv_value, $header_array);
					if (isset($value_array[$get_key])) {
						//$csv_element = $value_array[$get_key];	
						if ($file_extension == 'xml') {
							$csv_element = $value;
						} else {
							$csv_element = $value_array[$get_key];
						}
						$wp_element = trim($key);
						if (!empty($csv_element) && !empty($wp_element)) {
							$post_values[$wp_element] = $csv_element;
						}
					}
				}
			}

			if ($type == 'Images') {
				//changed
				if (array_key_exists('image_url', $post_values)) {
					$keys = array_keys($post_values);
					$keys[array_search('image_url', $keys)] = 'featured_image';
					$post_values = array_combine($keys, $post_values);
				}
				if (!empty($post_values['featured_image'])) {
					if (strpos($post_values['featured_image'], '|') !== false) {
						$featured_img = explode('|', $post_values['featured_image']);
						$post_values['featured_image'] = $featured_img[0];
					} else if (strpos($post_values['featured_image'], ',') !== false) {
						$feature_img = explode(',', $post_values['featured_image']);
						$post_values['featured_image'] = $feature_img[0];
					} else {
						$featured_image = $post_values['featured_image'];
						$post_values['featured_image'] = $featured_image;
					}
				}
				$poly_values = $helpers_instance->get_header_values($poly_array,$header_array,$value_array);
				$result = CoreFieldsImport::$media_instance->image_import($post_values, $check, $mode, $line_number, $unikey_value, $unikey_name,$poly_values);
			}
			if ($type == 'ngg_pictures') {
				$result = CoreFieldsImport::$nextgen_instance->nextgenGallery($post_values, $check, $mode, $line_number, $header_array, $value_array);
			}
			return $result;
		} else {

			$post_values = [];
			$current_user = wp_get_current_user();
		    $current_user_role = isset($current_user->roles[0]) ? $current_user->roles[0] : '';
			if($current_user_role == 'administrator'){
				$trim_content = array(
								'->static' => '', 
								'->math' => '', 
								'->cus1' => '',
								'->num' => '',
							);
				
				foreach($map as $header_keys => $value){
					if( strpos($header_keys, '->cus2') !== false) {
						if(!empty($value)){
							$helpers_instance->write_to_customfile($value, $header_array, $value_array);
							unset($map[$header_keys]);
						}
					}
					else{
						$header_trim = strtr($header_keys, $trim_content);
						if($header_trim != $header_keys){
							unset($map[$header_keys]);
						}
						$map[$header_trim] = $value;
					}
				}
			}
			$post_id = isset($post_id) ? $post_id : '';
			$get_result = null;
			foreach ($map as $key => $value) {
				$csv_value = trim($map[$key]);
				$extension_object = new ExtensionHandler;
				$import_type = $extension_object->import_type_as($type);
				$import_as = $extension_object->import_post_types($import_type);

				if (isset($csv_value) && $csv_value !== '') {
					//$pattern = "/({([a-z A-Z 0-9 | , _ -]+)(.*?)(}))/";
					$pattern1 = '/{([^}]*)}/';
					$pattern2 = '/\[([^\]]*)\]/';
					$file_table_name = $wpdb->prefix ."smackcf_file_events";
					$get_id = $wpdb->get_results( "SELECT file_name FROM $file_table_name WHERE `hash_key` = '$hash_key'");
					
					$file_name = !empty($get_id[0]->file_name) ? $get_id[0]->file_name : '';
					if(!empty($file_name) && isset($file_name)){
						$file_extension = pathinfo($file_name, PATHINFO_EXTENSION);
					}
					if(preg_match_all($pattern1, $csv_value, $matches, PREG_PATTERN_ORDER) && $file_extension !='xml'){		
						
						//check for inbuilt or custom function call -> enclosed in []
						if(preg_match_all($pattern2, $csv_value, $matches2)){
							$matched_element = $matches2[1][0];
							
							foreach($matches[1] as $value){
								$get_value = $helpers_instance->replace_header_with_values($value, $header_array, $value_array);
								$values = '{'.$value.'}';
								if(strpos($get_value , "'") !== false){
									$get_value=str_replace('"','\"',$get_value);
									$get_value = '"'.$get_value.'"';
								}
								else{
									$get_value = "'".$get_value."'";
								}

								$matched_element = str_replace($values, $get_value, $matched_element);
							}
							$csv_element = $helpers_instance->evalPhp($matched_element);
						}
						else{
							$csv_element = $csv_value;
							foreach ($matches[1] as $value) {
								$get_key = array_search($value, $header_array);
								if (isset($value_array[$get_key])) {
									$csv_value_element = $value_array[$get_key];
									$value = '{' . $value . '}';
									$csv_element = str_replace($value, $csv_value_element, $csv_element);
								}
							}
	
	
							$math = 'MATH';
							if (strpos($csv_element, $math) !== false) {
								$equation = str_replace('MATH', '', $csv_element);
								$csv_element = $helpers_instance->evalmath($equation);
							}
						}
						
						$wp_element = trim($key);

						if (!empty($csv_element) && !empty($wp_element)) {
							$post_values[$wp_element] = $csv_element;
							$post_values['post_type'] = $import_as;
							//$post_values = $this->import_core_fields($post_values,$line_number,$mode);

						}
					}
					// for custom function without headers in it
					elseif(preg_match_all($pattern2, $csv_value, $matches2) && $file_extension !='xml'){
						$matched_element = $matches2[1][0];
					
						$wp_element= trim($key);
						$csv_element1 = $helpers_instance->evalPhp($matched_element);
						$post_values[$wp_element] = $csv_element1;
					} 
					elseif (!in_array($csv_value, $header_array)) {
						$wp_element = trim($key);
						$post_values[$wp_element] = $csv_value;
						$post_values['post_type'] = $import_as;
						//$post_values = $this->import_core_fields($post_values,$line_number,$mode);
					} else {
						$get_key = array_search($csv_value, $header_array);
						if (isset($value_array[$get_key])) {
							$csv_element = $value_array[$get_key];
							$wp_element = trim($key);
							$extension_object = new ExtensionHandler;
							$import_type = $extension_object->import_type_as($type);
							$import_as = $extension_object->import_post_types($import_type);

							if ($mode == 'Insert') {
								if (!empty($csv_element) && !empty($wp_element)) {
									$post_values[$wp_element] = $csv_element;
									$post_values['post_type'] = $import_as;
									//	$post_values1 = $post_values;
									//$post_values = $this->import_core_fields($post_values,$line_number,$mode);
								}
							} else {
								if (!empty($csv_element) || !empty($wp_element)) {
									$post_values[$wp_element] = $csv_element;
									$post_values['post_type'] = $import_as;
									//$post_values = $this->import_core_fields($post_values,$line_number,$mode);
								}
							}

							if ($import_as == 'page') {
								if (isset($post_values['post_parent'])) {
									if (!is_numeric($post_values['post_parent'])) {
										$post_parent_title = $post_values['post_parent'];
										$post_parent_id = $wpdb->get_var("SELECT ID FROM {$wpdb->prefix}posts WHERE post_title = '$post_parent_title' AND post_type = 'page'");
										$post_values['post_parent'] = $post_parent_id;
									}
								}
							}
						}
					}
				}
			}
			$post_values = $this->import_core_fields($post_values, $line_number, $mode);
			if ($check == 'ID') {
				if(!empty($post_values['ID'])){
				$ID = $post_values['ID'];
				if(!empty($poly_values)){
					$language_code = $poly_values['language_code'];
					$get_result=$wpdb->get_results("SELECT p.ID FROM {$wpdb->prefix}posts as p inner join {$wpdb->prefix}term_relationships as tr ON tr.object_id=p.ID inner join {$wpdb->prefix}term_taxonomy as tax on tax.term_taxonomy_id=tr.term_taxonomy_id inner join {$wpdb->prefix}terms as t on t.term_id=tax.term_id  where tax.taxonomy ='language'  and t.slug='$language_code' and p.ID='$ID' AND p.post_status != 'trash' AND p.post_type = '$import_as'");
				}
				else{
					$get_result =  $wpdb->get_results("SELECT ID FROM {$wpdb->prefix}posts WHERE ID = '$ID' AND post_type = '$import_as' AND post_status != 'trash' order by ID DESC ");
				}
			}
			}
			if ($check == '_ID') {
				$ID = isset($post_values['_ID']) ? $post_values['_ID'] : '';
				return $ID;
			}
			if ($check == 'post_title') {
				if(!empty($post_values['post_title'])){
				$title = $post_values['post_title'];

				$title = $wpdb->_real_escape($title);
				// if(strpos($title,'&') !== false){
				// 	$title = str_replace('&','&amp;',$title);
				// }
				
				$poly_values = $helpers_instance->get_header_values($poly_array,$header_array,$value_array);
				if(!empty($poly_values)){
					$language_code = $poly_values['language_code'];
					$get_result=$wpdb->get_results("SELECT p.ID FROM {$wpdb->prefix}posts as p inner join {$wpdb->prefix}term_relationships as tr ON tr.object_id=p.ID inner join {$wpdb->prefix}term_taxonomy as tax on tax.term_taxonomy_id=tr.term_taxonomy_id inner join {$wpdb->prefix}terms as t on t.term_id=tax.term_id  where tax.taxonomy ='language'  and t.slug='$language_code' and p.post_title='$title' AND p.post_status != 'trash' AND p.post_type = '$import_as'");
				}else{
					$get_result =  $wpdb->get_results("SELECT ID FROM {$wpdb->prefix}posts WHERE post_title = '$title' AND post_type = '$import_as' AND post_status != 'trash' order by ID DESC ");
				}
				}
			}
			if ($check == 'post_name') {
				if(!empty($post_values['post_name'])){
				$name = $post_values['post_name'];
				if(!empty($poly_values)){
					$language_code = $poly_values['language_code'];
					$get_result=$wpdb->get_results("SELECT p.ID FROM {$wpdb->prefix}posts as p inner join {$wpdb->prefix}term_relationships as tr ON tr.object_id=p.ID inner join {$wpdb->prefix}term_taxonomy as tax on tax.term_taxonomy_id=tr.term_taxonomy_id inner join {$wpdb->prefix}terms as t on t.term_id=tax.term_id  where tax.taxonomy ='language'  and t.slug='$language_code' and p.post_name='$name' AND p.post_status != 'trash' AND p.post_type = '$import_as'");
				}
				else{
					$get_result =  $wpdb->get_results("SELECT ID FROM {$wpdb->prefix}posts WHERE post_name = '$name' AND post_type = '$import_as' AND post_status != 'trash' order by ID DESC ");
				}
			}
			}
			if ($check == 'post_content') {
				if(!empty($post_values['post_content'])){
				$content = $post_values['post_content'];
				$get_result =  $wpdb->get_results("SELECT ID FROM {$wpdb->prefix}posts WHERE post_content = '$content' AND post_type = '$import_as' AND post_status != 'trash' order by ID DESC ");
			}
			}
			$update = array('ID', 'post_title', 'post_name', 'post_content');

			if (!in_array($check, $update)) {
				if ($update_based_on == 'acf') {
					if (is_plugin_active('advanced-custom-fields-pro/acf.php') || is_plugin_active('advanced-custom-fields/acf.php') || is_plugin_active('secure-custom-fields/secure-custom-fields.php')) {
						if (is_array($acf)) {

							foreach ($acf as $acf_key => $acf_value) {
								if (strpos($acf_value, '{') !== false && strpos($acf_value, '}') !== false) {
									$acf_value = $acf_key;
								}
								if ($acf_key == $check) {
									$get_key = array_search($acf_value, $header_array);
								}
								if (isset($value_array[$get_key])) {
									$csv_element = $value_array[$get_key];
								}
								$get_result = $wpdb->get_results("SELECT post_id FROM {$wpdb->prefix}postmeta as a join {$wpdb->prefix}posts as b on a.post_id = b.ID WHERE a.meta_key = '$check' AND a.meta_value = '$csv_element' AND b.post_status != 'trash' AND b.post_type !='revision' order by a.post_id DESC ");
							}
						}
					}
				} else if ($update_based_on == 'jetengine') {

					if (is_plugin_active('jet-engine/jet-engine.php')) {
						$jetengine = !empty($jetengine) ? $jetengine : [];
						$jetengine = !empty($jetengine_cpt) ? $jetengine_cpt : [];
						if (!empty($jetengine) || !empty($jetengine_cpt) && is_array($jetengine) || is_array($jetengine_cpt)) {

							$jetengine_merge = array_merge($jetengine,$jetengine_cpt);

							foreach ($jetengine_merge as $jetengine_key => $jetengine_value) {

								if (strpos($jetengine_value, '{') !== false && strpos($jetengine_value, '}') !== false) {
									$jetengine_value = $jetengine_key;
								}
								if ($jetengine_key == $check) {
									

									$get_key = array_search($jetengine_value, $header_array);

								}
								if (isset($value_array[$get_key])) {
									$csv_element = $value_array[$get_key];
								}

								$get_result = $wpdb->get_results("SELECT post_id FROM {$wpdb->prefix}postmeta as a join {$wpdb->prefix}posts as b on a.post_id = b.ID WHERE a.meta_key = '$check' AND a.meta_value = '$csv_element' AND b.post_status != 'trash' AND b.post_type !='revision' order by a.post_id DESC ");
							
							}
						}
					}
				} else if ($update_based_on == 'metabox') {
					if (is_plugin_active('meta-box/meta-box.php')) {
						if (is_array($metabox)) {

							foreach ($metabox as $metabox_key => $metabox_value) {

								if (isset($metabox_value) && strpos($metabox_value, '{') !== false && strpos($metabox_value, '}') !== false) {
									$metabox_value = $metabox_key;
								}
								if ($metabox_key == $check) {
									$get_key = array_search($metabox_value, $header_array);
								}
								if (isset($value_array[$get_key])) {
									$csv_element = $value_array[$get_key];
								}
								$get_result = $wpdb->get_results("SELECT post_id FROM {$wpdb->prefix}postmeta as a join {$wpdb->prefix}posts as b on a.post_id = b.ID WHERE a.meta_key = '$check' AND a.meta_value = '$csv_element' AND b.post_status != 'trash' AND b.post_type !='revision' order by a.post_id DESC ");
							}
						}
					}
				} elseif ($update_based_on == 'toolset') {
					if (is_plugin_active('types/wpcf.php')) {
						if (is_array($toolset)) {

							foreach ($toolset as $tool_key => $tool_value) {
								if (strpos($tool_value, '{') !== false && strpos($tool_value, '}') !== false) {
									$tool_value = $tool_key;
								}
								if ($tool_key == $check) {
									$get_key = array_search($tool_value, $header_array);
								}
								if (isset($value_array[$get_key])) {
									$csv_element = $value_array[$get_key];
								}
								$meta_key = 'wpcf-' . $check;
								$get_result = $wpdb->get_results("SELECT post_id FROM {$wpdb->prefix}postmeta as a join {$wpdb->prefix}posts as b on a.post_id = b.ID WHERE a.meta_key = '$meta_key' AND a.meta_value = '$csv_element' AND b.post_status != 'trash' order by a.post_id DESC ");
							}
						}
					}
				}
				if ($update_based_on == 'pods') {
					if (is_plugin_active('pods/init.php')) {
						if (is_array($pods)) {
							foreach ($pods as $pods_key => $pods_value) {
								if (strpos($pods_value, '{') !== false && strpos($pods_value, '}') !== false) {
									$pods_value = $pods_key;
								}
								if ($pods_key == $check) {
									$get_key = array_search($pods_value, $header_array);
								}
								if (isset($value_array[$get_key])) {
									$csv_element = $value_array[$get_key];
								}
								$get_result = $wpdb->get_results("SELECT post_id FROM {$wpdb->prefix}postmeta as a join {$wpdb->prefix}posts as b on a.post_id = b.ID WHERE a.meta_key = '$check' AND a.meta_value = '$csv_element' AND b.post_status != 'trash' order by a.post_id DESC ");
							}
						}
					}
				}
			}
			/** Update or Insert based on categories */
			if ($isCategory) {
				$get_result_check = $this->get_matching_posts_by_category($helpers_instance, $post_cat_list,$categoryList, $header_array, $value_array, $import_type, $import_as, $wpdb,$get_result,$mode);
				if (($mode == 'Import-Update' || $mode == 'Update')  && !empty($check) && !empty($get_result) && !$get_result_check) {
					$get_result = [];
				}
			}

			if($this->generated_content){
				$generated_content = $post_values['post_content'];
				if($generated_content == 401 ||$generated_content == 429 ||$generated_content == 500 ||$generated_content == 503 ||$generated_content == 400){
					$post_values['post_content'] = '';
				}
			}
			if($this->generated_content){
				$generated_short_description = $post_values['post_excerpt'];
				if($generated_short_description == 401 ||$generated_short_description == 429 ||$generated_short_description == 500 ||$generated_short_description == 503 ||$generated_short_description == 400){
					$post_values['post_excerpt'] = '';
				}
			}

			if ($mode == 'Insert') {
				if($isCategory && !($get_result_check)){
					$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
					$this->detailed_log[$line_number]['Message'] =  "Skipped, Record does not match the selected categories.";
					$this->detailed_log[$line_number]['state'] = 'Skipped';
				}
				else if (is_array($get_result) && !empty($get_result)) {
					$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
					$this->detailed_log[$line_number]['Message'] =  "Skipped, Due to duplicate found!.";
					$this->detailed_log[$line_number]['state'] = 'Skipped';
				} elseif (!empty($this->detailed_log) && isset($this->detailed_log[$line_number]) && preg_match("(Skipped)", $this->detailed_log[$line_number]['Message']) != 0) {
					$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
				} else {
					$media_handle = get_option('smack_image_options');
					if (isset($post_values['post_parent'])) {
						if (!is_numeric($post_values['post_parent']) && !empty($post_values['post_parent'])) {
							$p_type = $post_values['post_type'];
							$parent_title = $post_values['post_parent'];
							$parent_id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_title = '$parent_title' and post_status !='trash' and post_type='$p_type'");
							$post_values['post_parent'] = $parent_id;
						}
					}

					if (isset($post_values['ID'])) {
						unset($post_values['ID']);
					}
					$post_values['post_content']=isset($post_values['post_content'])?$post_values['post_content']:'';
					$post_values['post_content'] = html_entity_decode($post_values['post_content']);	

					$post_id = wp_insert_post($post_values);
					if (!empty($post_values['wp_page_template'])) {
						update_post_meta($post_id, '_wp_page_template', $post_values['wp_page_template']);
					}

					if ($post_values['post_status'] == 'delete') {
						$post_title = $post_values['post_title'];
						$post_id = $wpdb->get_results("select ID from {$wpdb->prefix}posts where post_title = '$post_title'");
						foreach ($post_id as $value) {
							$posts = $value->ID;
							wp_delete_post($posts, true);
						}
					}

					if ($unmatched_row == 'true') {
						global $wpdb;
						$post_entries_table = $wpdb->prefix . "post_entries_table";
						if($line_number == 0){
							$wpdb->get_results("DELETE FROM $post_entries_table WHERE type= '$type'");	
						}
						$file_table_name = $wpdb->prefix . "smackcf_file_events";
						$get_id  = $wpdb->get_results("SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");
						$file_name = $get_id[0]->file_name;
						$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$post_id}','{$type}', '{$file_name}','Inserted')");
					}

					if (isset($post_values['post_format'])) {
						$format = str_ireplace("post-format-", "", $post_values['post_format']);
						set_post_format($post_id, $format);
					}
					$post_values['post_content'] = isset($post_values['post_content']) ? $post_values['post_content'] : '';

					if ($media_handle['media_settings']['media_handle_option'] == 'true' && $media_handle['media_settings']['enable_postcontent_image'] == 'true') {
						if (preg_match("/<img/", $post_values['post_content'])) {

							$content = "<p>" . $post_values['post_content'] . "</p>";
							$doc = new \DOMDocument();
							#$doc->preserveWhiteSpace = false;
							if (function_exists('mb_convert_encoding')) {
								@$doc->loadHTML(mb_convert_encoding($content, 'HTML-ENTITIES', 'UTF-8'), LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
							} else {
								@$doc->loadHTML($content);
							}
							$searchNode = $doc->getElementsByTagName("img");
							if (!empty($searchNode)) {
								foreach ( $searchNode as $searchNodes ) {
									$orig_img_src[] = $searchNodes->getAttribute( 'src' ); 
								}
										
								$media_dir = wp_get_upload_dir();
								$names = $media_dir['url'];
								if(isset($orig_img_src)){
									$shortcode_table = $wpdb->prefix . "ultimate_cf_importer_shortcode_manager";
									$indexs = 0;
									foreach ($orig_img_src as $img_val){
										$shortcode  = 'inline';
										CoreFieldsImport::$media_instance->store_image_ids($i=1);
										CoreFieldsImport::$media_instance->image_meta_table_entry($line_number,$post_values,$post_id ,'',$img_val, $hash_key ,$shortcode,$import_type,'','',$header_array,$value_array,'','',$indexs);
										$indexs++;																				
									}
								}
								$post_content              = $doc->saveHTML();
								$post_values['post_content'] = $post_content;
								$update_content['ID']           = $post_id;
								$update_content['post_content'] = $post_content;
								wp_update_post( $update_content );
							}
						}
					}
					$wpdb->get_results("UPDATE $log_table_name SET created = $created_count WHERE $unikey_name = '$unikey_value'");
					if(!empty($post_values['post_content']) && $media_handle['media_settings']['enable_postcontent_image'] == 'false') {
						$dom = new \DOMDocument();
                        @$dom->loadHTML($post_values['post_content']);
                        $xpath = new \DOMXPath($dom);
                        $searchNode = $xpath->query('//img[@src]');
						$i = 1;
						foreach ( $searchNode as $searchNodes ) {
							$orig_img_src[] = $searchNodes->getAttribute( 'src' );
							if(!empty($orig_img_src)){
								CoreFieldsImport::$media_instance->store_image_ids($i);
							}
							$i++;
						}	
							$media_dir = wp_get_upload_dir();
							$names = $media_dir['url'];
					}


					if (is_wp_error($post_id) || $post_id == '') {
						if (is_wp_error($post_id)) {
							$this->detailed_log[$line_number]['Message'] = "Can't insert this " . $post_values['post_type'] . ". " . $post_id->get_error_message();
							$this->detailed_log[$line_number]['state'] = 'Skipped';
						} else {
							$this->detailed_log[$line_number]['Message'] =  "Can't insert this " . $post_values['post_type'];
							$this->detailed_log[$line_number]['state'] = 'Skipped';
						}
						$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
					} else {
						$post_values['specific_author'] = isset($post_values['specific_author']) ? $post_values['specific_author'] : '';
						$content=$this->openAI_response;
						if(!empty($content)){
							if($generated_content == 401) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Invalid API key provided. Please check your API key.";
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_content == 429) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Rate limit reached for requests or You exceeded your current quota.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_content == 400) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Please check your Inputs.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_content == 500) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. The server had an error while processing your request.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_content == 503) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. The engine is currently overloaded, please try again later.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_short_description == 401) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Invalid API key provided. Please check your API key.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_short_description == 429) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Rate limit reached for requests or You exceeded your current quota.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_short_description == 400) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Please check your Inputs.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_short_description == 500) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. The server had an error while processing your request.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else if($generated_short_description == 503) {
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. The engine is currently overloaded, please try again later.";	
								$this->detailed_log[$line_number]['state'] = 'Inserted';
							}
							else{
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
								$author = explode('</b>',$post_values['specific_author']);
								$this->detailed_log[$line_number]['id'] = $post_id;
								$this->detailed_log[$line_number]['state'] = 'Inserted';
								$this->detailed_log[$line_number]['author'] = end($author);
							}
						}
						else{
							$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
							$author = explode('</b>',$post_values['specific_author']);
							$this->detailed_log[$line_number]['id'] = $post_id;
							$this->detailed_log[$line_number]['state'] = 'Inserted';
							$this->detailed_log[$line_number]['author'] = end($author);
						}
					}
				}
			}

			if ($mode == 'Import-Update' || $mode == 'Update') {
				if($isCategory && empty($get_result)){
					$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
					$this->detailed_log[$line_number]['Message'] =  "Skipped, Record does not match the selected categories.";
					$this->detailed_log[$line_number]['state'] = 'Skipped';
				}
				if (!empty($this->detailed_log) && isset($this->detailed_log[$line_number]) && preg_match("(Skipped)", $this->detailed_log[$line_number]['Message']) != 0) {
					$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
				} else {
					if (is_array($get_result) && !empty($get_result)) {

						if (!in_array($check, $update)) {
							$post_id = $get_result[0]->post_id;
							$post_values['ID'] = $post_id;
						} else {
							$post_id = $get_result[0]->ID;
							$post_values['ID'] = $post_id;
						}

						$media_handle = get_option('smack_image_options');
						if ($media_handle['media_settings']['media_handle_option'] == 'true' && $media_handle['media_settings']['enable_postcontent_image'] == 'true') {
							if (preg_match("/<img/", $post_values['post_content'])) {
	
								$content = "<p>" . $post_values['post_content'] . "</p>";
								$doc = new \DOMDocument();
								#$doc->preserveWhiteSpace = false;
								if (function_exists('mb_convert_encoding')) {
									@$doc->loadHTML(mb_convert_encoding($content, 'HTML-ENTITIES', 'UTF-8'), LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
								} else {
									@$doc->loadHTML($content);
								}
								$searchNode = $doc->getElementsByTagName("img");
								if (!empty($searchNode)) {
									foreach ( $searchNode as $searchNodes ) {
										$orig_img_src[] = $searchNodes->getAttribute( 'src' ); 
									}
											
									$media_dir = wp_get_upload_dir();
									$names = $media_dir['url'];
									if(isset($orig_img_src)){
										$shortcode_table = $wpdb->prefix . "ultimate_cf_importer_shortcode_manager";
										$indexs = 0;
										foreach ($orig_img_src as $img_val){
											$shortcode  = 'inline';
											CoreFieldsImport::$media_instance->store_image_ids($i=1);
											CoreFieldsImport::$media_instance->image_meta_table_entry($line_number,$post_values,$post_id ,'',$img_val, $hash_key ,$shortcode,$import_type,'','',$header_array,$value_array,'','',$indexs);
											$indexs++;																				
										}
									}
									$post_content              = $doc->saveHTML();
									$post_values['post_content'] = $post_content;
									$update_content['ID']           = $post_id;
									$update_content['post_content'] = $post_content;
									wp_update_post( $update_content );
								}
							}
						}					
						wp_update_post($post_values);
						if(!empty($post_values['post_content']) && $media_handle['media_settings']['media_handle_option'] == 'false' && preg_match("/<img/", $post_values['post_content'])) {
							$dom = new \DOMDocument();
							@$dom->loadHTML($post_values['post_content']);
							$xpath = new \DOMXPath($dom);
							$searchNode = $xpath->query('//img[@src]');
							$i=1;
							foreach ( $searchNode as $searchNodes ) {
								$orig_img_src[] = $searchNodes->getAttribute( 'src' );
								if(!empty($orig_img_src)){
									CoreFieldsImport::$media_instance->store_image_ids($i);
								}
							}		
							
							$media_dir = wp_get_upload_dir();
							$names = $media_dir['url'];
						}


						if ($unmatched_row == 'true') {
							global $wpdb;
							$post_entries_table = $wpdb->prefix . "post_entries_table";
							if($line_number == 0){
								$wpdb->get_results("DELETE FROM $post_entries_table WHERE type= '$type'");	
							}
							$file_table_name = $wpdb->prefix . "smackcf_file_events";
							$get_id  = $wpdb->get_results("SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");
							$file_name = $get_id[0]->file_name;
							$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$post_id}','{$type}', '{$file_name}','Updated')");
						}

						$post_values['post_content'] = isset($post_values['post_content']) ? $post_values['post_content'] : '';
						if (isset($post_values['post_format'])) {
							$format = str_ireplace("post-format-", "", $post_values['post_format']);
							set_post_format($post_id, $format);
						}
						$wpdb->get_results("UPDATE $log_table_name SET updated = $updated_count WHERE $unikey_name = '$unikey_value'");
						$content=$this->openAI_response;
						if(!empty($content)){
							if($generated_content == 401) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Invalid API key provided. Please check your API key.";
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_content == 429) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Rate limit reached for requests or You exceeded your current quota.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_content == 400) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Please check your Inputs.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_content == 500) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. The server had an error while processing your request.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_content == 503) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. The engine is currently overloaded, please try again later.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_short_description == 401) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Invalid API key provided. Please check your API key.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_short_description == 429) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Rate limit reached for requests or You exceeded your current quota.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_short_description == 400) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Please check your Inputs.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_short_description == 500) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. The server had an error while processing your request.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else if($generated_short_description == 503) {
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. The engine is currently overloaded, please try again later.";	
								$this->detailed_log[$line_number]['state'] = 'Updated';
							}
							else{
								$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
								$this->detailed_log[$line_number]['id'] = $post_id;
								$this->detailed_log[$line_number]['state'] = 'Updated';
								$author = explode('</b>',$post_values['specific_author']);
								$this->detailed_log[$line_number]['author'] = end($author);
							}
						}
						else{
							$this->detailed_log[$line_number]['Message'] = 'Updated ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
							$this->detailed_log[$line_number]['id'] = $post_id;
							$this->detailed_log[$line_number]['state'] = 'Updated';
							$author = explode('</b>',$post_values['specific_author']);
							$this->detailed_log[$line_number]['author'] = end($author);
						}
					} else {

						unset($post_values['ID']);
						if(isset($post_values['post_content'])){
							$post_values['post_content'] = html_entity_decode($post_values['post_content']);																
						}
						$post_id = wp_insert_post($post_values);
						$media_handle = get_option('smack_image_options');
						if ($media_handle['media_settings']['media_handle_option'] == 'true'  && $media_handle['media_settings']['enable_postcontent_image'] == 'true') {

							if (preg_match("/<img/", $post_values['post_content'])) {

								$content = "<p>" . $post_values['post_content'] . "</p>";
								$doc = new \DOMDocument();
								if (function_exists('mb_convert_encoding')) {
									@$doc->loadHTML(mb_convert_encoding($content, 'HTML-ENTITIES', 'UTF-8'), LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
								} else {
									@$doc->loadHTML($content);
								}
								$searchNode = $doc->getElementsByTagName("img");
								if (!empty($searchNode)) {
									foreach ($searchNode as $searchNode) {
										$orig_img_src = $searchNode->getAttribute('src');
										$media_dir = wp_get_upload_dir();
										$names = $media_dir['url'];

										if (strpos($orig_img_src, $names) !== false) {
											$shortcode_img = $orig_img_src;
										} else {
											$rand = mt_rand(1, 999);
											$shortcode_table = $wpdb->prefix . "ultimate_cf_importer_shortcode_manager";
											$get_shortcode = $wpdb->get_results("SELECT `image_shortcode` FROM $shortcode_table WHERE original_image = '{$orig_img_src}' ", ARRAY_A);
											if (!empty($get_shortcode)) {
												$shortcode_img = $get_shortcode[0]['image_shortcode'];
											} else {
												$shortcode_img = 'inline_' . $rand . '_' . $orig_img_src;
											}
										}
										$temp_img = plugins_url("../assets/images/loading-image.jpg", __FILE__);
										$searchNode->setAttribute('src', $temp_img);
										$searchNode->setAttribute('alt', $shortcode_img);
									}
									$post_content              = $doc->saveHTML();
									$post_values['post_content'] = $post_content;
									$update_content['ID']           = $post_id;
									$update_content['post_content'] = $post_content;
									wp_update_post($update_content);
								}
							}
						}
						if (!empty($post_values['wp_page_template']) && $type == 'Pages') {
							update_post_meta($post_id, '_wp_page_template', $post_values['wp_page_template']);
						}


						if ($unmatched_row == 'true') {
							global $wpdb;
							$post_entries_table = $wpdb->prefix . "post_entries_table";
							if($line_number == 0){
								$wpdb->get_results("DELETE FROM $post_entries_table WHERE type= '$type'");	
							}
							$file_table_name = $wpdb->prefix . "smackcf_file_events";
							$get_id  = $wpdb->get_results("SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");
							$file_name = $get_id[0]->file_name;
							$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$post_id}','{$type}', '{$file_name}','Inserted')");
						}

						if (isset($post_values['post_format'])) {
							$format = str_ireplace("post-format-", "", $post_values['post_format']);
							set_post_format($post_id, $format);
						}

						$wpdb->get_results("UPDATE $log_table_name SET created = $created_count WHERE $unikey_name = '$unikey_value'");
						if (preg_match("/<img/", $post_values['post_content'])) {
							$shortcode_table = $wpdb->prefix . "ultimate_cf_importer_shortcode_manager";
							$doc = new \DOMDocument();
							$searchNode = $doc->getElementsByTagName("img");
							if (!empty($searchNode)) {
								foreach ($searchNode as $searchNode) {
									$orig_img_src = $searchNode->getAttribute('src');
								}
							}
							if (isset($orig_img_src) && !empty($orig_img_alt)) {
								foreach ($orig_img_src as $img => $img_val) {
									$shortcode  = 'Inline';
									$wpdb->get_results("INSERT INTO $shortcode_table (image_shortcode , original_image , post_id,hash_key,templatekey) VALUES ( '{$shortcode}', '{$img_val}', $post_id  ,'{$hash_key}','{$templatekey}')");
								}
							}
							//$wpdb->get_results("INSERT INTO $shortcode_table (image_shortcode , original_image , post_id,hash_key) VALUES ( '{$shortcode_img}', '{$orig_img_src}', $post_id  ,'{$hash_key}')");
						}
						if (is_wp_error($post_id) || $post_id == '') {
							if (is_wp_error($post_id)) {
								$this->detailed_log[$line_number]['Message'] = "Can't insert this " . $post_values['post_type'] . ". " . $post_id->get_error_message();
								$this->detailed_log[$line_number]['state'] = 'Skipped';
							} else {
								$this->detailed_log[$line_number]['Message'] =  "Can't insert this " . $post_values['post_type'];
								$this->detailed_log[$line_number]['state'] = 'Skipped';
							}
							$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
						} else {
							$content=$this->openAI_response;
							if(!empty($content)){
								if($generated_content == 401) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Invalid API key provided. Please check your API key.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_content == 429) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Rate limit reached for requests or You exceeded your current quota.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_content == 400) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. Please check your Inputs.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_content == 500) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. The server had an error while processing your request.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_content == 503) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create Content. The engine is currently overloaded, please try again later.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_short_description == 401) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Invalid API key provided. Please check your API key.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_short_description == 429) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Rate limit reached for requests or You exceeded your current quota.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_short_description == 400) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. Please check your Inputs.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_short_description == 500) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. The server had an error while processing your request.";	
									$this->detailed_log[$line_number]['state'] = 'Inserted';
								}
								else if($generated_short_description == 503) {
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author']. 	"<b style='color: red;'> Notice : </b>Cannot create short description. The engine is currently overloaded, please try again later.";	
								}
								else{
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
									$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
									$this->detailed_log[$line_number]['id'] = $post_id;
									$this->detailed_log[$line_number]['state'] = 'Inserted';
									$author = explode('</b>',$post_values['specific_author']);
									$this->detailed_log[$line_number]['author'] = end($author);
								}
							}
							else{
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
								$this->detailed_log[$line_number]['Message'] = 'Inserted ' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
								$this->detailed_log[$line_number]['id'] = $post_id;
								$this->detailed_log[$line_number]['state'] = 'Inserted';
								$author = explode('</b>',$post_values['specific_author']);
								$this->detailed_log[$line_number]['author'] = end($author);
							}
						}
						// if( $post_values['post_type'] == 'page'){
						// 	$status = $post_values1['post_status'];
						// 	$wpdb->get_results("UPDATE {$wpdb->prefix}posts set post_status = '$status' where id = $post_id");
						// }
					}
				}
			}
			if ($mode == 'Updates') {
				if (!empty($this->detailed_log) && isset($this->detailed_log[$line_number]) && preg_match("(Skipped)", $this->detailed_log[$line_number]['Message']) != 0) {
					$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
				} else {
					if (is_array($get_result) && !empty($get_result)) {
						if (!in_array($check, $update)) {
							$post_id = $get_result[0]->post_id;
							$post_values['ID'] = $post_id;
						} else {
							$post_id = $get_result[0]->ID;
							$post_values['ID'] = $post_id;
						}
						$media_handle = get_option('smack_image_options');
						if ($media_handle['media_settings']['media_handle_option'] == 'true' && $media_handle['media_settings']['enable_postcontent_image'] == 'true') {
							if (preg_match("/<img/", $post_values['post_content'])) {

								$content = "<p>" . $post_values['post_content'] . "</p>";
								$doc = new \DOMDocument();
								#$doc->preserveWhiteSpace = false;
								if (function_exists('mb_convert_encoding')) {
									@$doc->loadHTML(mb_convert_encoding($content, 'HTML-ENTITIES', 'UTF-8'), LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
								} else {
									@$doc->loadHTML($content);
								}
								$searchNode = $doc->getElementsByTagName("img");
								if (!empty($searchNode)) {
									foreach ($searchNode as $searchNode) {
										$orig_img_src[] = $searchNode->getAttribute('src');
										if (!empty($orig_img_src))
											$url = $orig_img_src[0];
										$media_dir = wp_get_upload_dir();
										$names = $media_dir['url'];

										$shortcode_img[] = $orig_img_src;

										$temp_img = plugins_url("../assets/images/loading-image.jpg", __FILE__);
										$searchNode->setAttribute('src', $temp_img);
										//	$searchNode->setAttribute( 'alt', $shortcode_img );

										$orig_img_alt = $searchNode->getAttribute('alt');
										if (!empty($orig_img_alt)) {
											$media_handle['postcontent_image_alt'] = $orig_img_alt;
											update_option('smack_image_options', $media_handle);
										}
									}
									$post_content              = $doc->saveHTML();
									$post_values['post_content'] = $post_content;
									$update_content['ID']           = $post_id;
									$update_content['post_content'] = $post_content;
									wp_update_post($update_content);
								}
							}
						}

						if (empty($post_values['post_status'])) {
							global $wpdb;
							$post_id = $get_result[0]->ID;
							$Post_status_value = $wpdb->get_results("SELECT post_status FROM {$wpdb->prefix}posts WHERE id = '$post_id'");
							$post_values['post_status'] = $Post_status_value[0]->post_status;
						}
						if ($post_values['post_status'] == 'delete') {
							wp_delete_post($post_values['ID'], true);
						} else {
							wp_update_post($post_values);
						}


						if ($unmatched_row == 'true') {
							global $wpdb;
							$post_entries_table = $wpdb->prefix . "post_entries_table";
							if($line_number == 0){
								$wpdb->get_results("DELETE FROM $post_entries_table WHERE type= '$type'");	
							}
							$file_table_name = $wpdb->prefix . "smackcf_file_events";
							$get_id  = $wpdb->get_results("SELECT file_name  FROM $file_table_name WHERE `hash_key` = '$hash_key'");
							$file_name = $get_id[0]->file_name;
							$wpdb->get_results("INSERT INTO $post_entries_table (`ID`,`type`, `file_name`,`status`) VALUES ( '{$post_id}','{$type}', '{$file_name}','Updated')");
						}

						//if(preg_match("/<img/", $post_values['post_content'])) {
						if (!empty($post_values['post_content']) && preg_match("/<img/", $post_values['post_content'])) {
							$shortcode_table = $wpdb->prefix . "ultimate_cf_importer_shortcode_manager";
							foreach ($orig_img_src as $img => $img_val) {
								//$shortcode  = $shortcode_img[$img][$img];
								$shortcode  = 'Inline';
								$wpdb->get_results("INSERT INTO $shortcode_table (image_shortcode , original_image , post_id,hash_key,templatekey) VALUES ( '{$shortcode}', '{$img_val}', $post_id  ,'{$hash_key}','{$templatekey}')");
							}
							$doc = new \DOMDocument();
							$searchNode = $doc->getElementsByTagName("img");
							if (!empty($searchNode)) {
								foreach ($searchNode as $searchNode) {
									$orig_img_src = $searchNode->getAttribute('src');
								}
								foreach ($orig_img_src as $img => $img_val) {
									$shortcode  = 'Inline';
									$wpdb->get_results("INSERT INTO $shortcode_table (image_shortcode , original_image , post_id,hash_key,templatekey) VALUES ( '{$shortcode}', '{$img_val}', $post_id  ,'{$hash_key}','{$templatekey}')");
								}
							}
						}

						if (isset($post_values['post_format'])) {
							$format = str_ireplace("post-format-", "", $post_values['post_format']);
							set_post_format($post_id, $format);
						}
						$status = $post_values['post_status'];
						$wpdb->get_results("UPDATE {$wpdb->prefix}posts set post_status = '$status' where id = $post_id");
						$wpdb->get_results("UPDATE $log_table_name SET updated = $updated_count WHERE $unikey_name = '$unikey_value'");
						$this->detailed_log[$line_number]['Message'] = 'Updated' . $post_values['post_type'] . ' ID: ' . $post_id . ', ' . $post_values['specific_author'];
						$this->detailed_log[$line_number]['id'] = $post_id;
						$this->detailed_log[$line_number]['state'] = 'Updated';
						$author = explode('</b>',$post_values['specific_author']);
						$this->detailed_log[$line_number]['author'] = end($author);
					} else {
						$mode_of_affect = 'Skipped';
						$this->detailed_log[$line_number]['Message'] = "Skipped";
						$this->detailed_log[$line_number]['state'] = 'Skipped';
						$wpdb->get_results("UPDATE $log_table_name SET skipped = $skipped_count WHERE $unikey_name = '$unikey_value'");
						//return $mode_of_affect;
					}
				}
			}
			if (preg_match("(Can't|Skipped|Duplicate)", $this->detailed_log[$line_number]['Message']) === 0) {
				if ($type == 'Posts' || $type == 'CustomPosts' || $type == 'Pages') {
					if (!isset($post_values['post_title'])) {
						$post_values['post_title'] = '';
					}
					if ($gmode == 'Normal') {
						//$this->detailed_log[$line_number]['VERIFY'] = "<b> Click here to verify</b> - <a href='" . get_permalink( $post_id ) . "' target='_blank' title='" . esc_attr( sprintf( __( 'View &#8220;%s&#8221;' ), $post_values['post_title'] ) ) . "'rel='permalink'>Web View</a> | <a href='" . get_edit_post_link( $post_id, true ) . "'target='_blank' title='" . esc_attr( 'Edit this item' ) . "'>Admin View</a>";
						$this->detailed_log[$line_number]['webLink'] = get_permalink( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id, true );
						$this->detailed_log[$line_number]['post_type'] = get_post_type($post_id);
					   $this->detailed_log[$line_number]['post_title'] = get_the_title($post_id);
					} else {
						global $wpdb;
						if (empty($post_id)) {
							$this->detailed_log[$line_number]['Message'] = 'Skipped';
							$this->detailed_log[$line_number]['state'] = 'Skipped';
						} else {
							$get_guid = $wpdb->get_results("select guid from {$wpdb->prefix}posts where ID= '$post_id'", ARRAY_A);
							$link = $get_guid[0]['guid'];
							$get_edit_link = get_edit_post_link($post_id, true);
							if (empty($get_edit_link)) {
								$get_edit_link = site_url() . '/wp-admin/post.php?&post=' . $post_id . '&action=edit';
							}
							$this->detailed_log[$line_number]['webLink'] = get_permalink( $post_id );
							$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id, true );
							$this->detailed_log[$line_number]['post_type'] = get_post_type($post_id);
						   $this->detailed_log[$line_number]['post_title'] = get_the_title($post_id);
						}
					}
					//$this->detailed_log[$line_number]['VERIFY'] = "<b> Click here to verify</b> - <a href='" . get_permalink( $post_id ) . "' target='_blank' title='" . esc_attr( sprintf( __( 'View &#8220;%s&#8221;' ), $post_values['post_title'] ) ) . "'rel='permalink'>Web View</a> | <a href='" . get_edit_post_link( $post_id, true ) . "'target='_blank' title='" . esc_attr( 'Edit this item' ) . "'>Admin View</a>";
				} else {
					if($type == 'llms_coupon'){
						//$this->detailed_log[$line_number]['VERIFY'] = "<b> Click here to verify</b> - <a href='" . get_edit_post_link( $post_id, true ) . "'target='_blank' title='" . esc_attr( 'Edit this item' ) . "'>Admin View</a>";
						$this->detailed_log[$line_number]['webLink'] = get_permalink( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id, true );
						$this->detailed_log[$line_number]['post_type'] = get_post_type($post_id);
					   $this->detailed_log[$line_number]['post_title'] = get_the_title($post_id);
					}
					else{
						$this->detailed_log[$line_number]['webLink'] = get_permalink( $post_id );
						$this->detailed_log[$line_number]['adminLink'] = get_edit_post_link( $post_id, true );
						$this->detailed_log[$line_number]['post_type'] = get_post_type($post_id);
					   $this->detailed_log[$line_number]['post_title'] = get_the_title($post_id);
					}
				}
				$this->detailed_log[$line_number]['Status'] = $post_values['post_status'];
			}

			if (isset($post_values['featured_image'])) {
				if (!empty($post_id) && !is_plugin_active('featured-image-from-url/featured-image-from-url.php')) {
					if (strpos($post_values['featured_image'], '|') !== false) {
						$featured_img = explode('|', $post_values['featured_image']);
						$post_values['featured_image'] = $featured_img[0];
					} else if (strpos($post_values['featured_image'], ',') !== false) {
						$feature_img = explode(',', $post_values['featured_image']);
						$post_values['featured_image'] = $feature_img[0];
					} else {
						$post_values['featured_image'] = $post_values['featured_image'];
					}
					if (preg_match_all('/\b[-A-Z0-9+&@#\/%=~_|$?!:,.]*[A-Z0-9+&@#\/%=~_|$]/i', $post_values['featured_image'], $matchedlist, PREG_PATTERN_ORDER)) {
						$attach_id = $helpers_instance->featured_image_handling($post_values, $post_id, $type,$import_type,$unikey_value, $unikey_name, $header_array, $value_array, $hash_key, $templatekey,$line_number);
					}
				}
			}
			return $post_id;
		}
	}
	public function replace_header_with_values($csv_header, $header_array, $value_array){
		$csv_value = $csv_header;
		$get_key = array_search($csv_header , $header_array);
		if(isset($value_array[$get_key])){
			$csv_value = $value_array[$get_key];
		}
		return $csv_value;
	}

	//Image Handling used to handle the inline image
	public function image_handling($id,$attach_id,$index){
		global $wpdb;
		// Retrieve the current post content
		$get_result = $wpdb->get_results("SELECT post_content FROM {$wpdb->prefix}posts WHERE ID = $id", ARRAY_A);
		if (empty($get_result)) {
			$post_content = '';
		} else {
			$post_content = htmlspecialchars_decode($get_result[0]['post_content']);
		}
		// Retrieve the attachment URL
		$get_guid = $wpdb->get_results("SELECT guid FROM {$wpdb->prefix}posts WHERE post_type = 'attachment' AND ID = $attach_id", ARRAY_A);
		if (empty($get_guid)) {
			return null; // Return if the attachment is not found
		}
		$new_img_src = $get_guid[0]['guid'];
		// Load the post content into DOMDocument
		$doc = new \DOMDocument();
		if (function_exists('mb_convert_encoding')) {
			@$doc->loadHTML(mb_convert_encoding($post_content, 'HTML-ENTITIES', 'UTF-8'), LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
		} else {
			@$doc->loadHTML($post_content);
		}
	
		// Get all img tags
		$img_tags = $doc->getElementsByTagName('img');
		// Update the img tag at the specified index
		if ($img_tags->length > $index) {
			$img_tags->item($index)->setAttribute('src', $new_img_src);
		} else {
			return null; // Return if the index is out of bounds
		}
	
		// Save the updated content
		$result = $doc->saveHTML();
		$update_content = [
			'ID' => $id,
			'post_content' => $result,
		];
	
		// Update the post content
		$check = wp_update_post($update_content);
		return $attach_id;
	}


	function import_core_fields($data_array, $line_number, $mode = null)
	{

		$helpers_instance = ImportHelpers::getInstance();

		$data_array = $this->validateDate($data_array, $line_number, $mode);
		if (!isset($data_array['post_author']) && $mode != 'Update') {

			$data_array['post_author'] = 1;
		} else {
			if (isset($data_array['post_author'])) {
				$user_records = $helpers_instance->get_from_user_details($data_array['post_author']);
				$data_array['post_author'] = $user_records['user_id'];
				$data_array['specific_author'] = $user_records['message'];
			}
		}
		if (!empty($data_array['post_status'])) {
			$data_array = $helpers_instance->assign_post_status($data_array);
		} else {
			$data_array['post_status'] = 'publish';
		}
		return $data_array;
	}

	function replaceValues($array) {
		foreach ($array as $innerKey => $innerValue) {
			if (strpos($innerKey, '->openAI') !== false) {
				$newKey = str_replace('->openAI', '', $innerKey);
				$array[$newKey] = $newKey;
				unset($array[$innerKey]);
			}
		}
		return $array;
	}

	function filterNumKeys($array) {
		foreach ($array as $key => $value) {
			if (is_array($value)) {
				$array[$key] = $this->filterNumKeys($value);
			} else {
				if (strpos($key, '->num') !== false) {
					unset($array[$key]);
				}
			}
		}
		return $array;
	}
	public function validateDate($data_array,$mode,$line_number) {
	if(empty( $data_array['post_date'] )) {
		if($mode == 'insert'){
		$data_array['post_date'] = current_time('Y-m-d H:i:s');
		}
		else {
			//For update
			return $data_array;
		}
	} else {					
		//Validate the date
		if(strtotime( $data_array['post_date'] )) {	
			if(strtotime($data_array['post_date'])> 0)	{
				if (strpos($data_array['post_date'], '.') !== false) {
					$data_array['post_date'] = str_replace('.', '-', $data_array['post_date']);
				}
				$data_array['post_date'] = date( 'Y-m-d H:i:s', strtotime( $data_array['post_date'] ) );									
			}								
			else{
				if($data_array['post_date'] == '0000-00-00T00:00' || $data_array['post_date'] == '0000-00-00'){
					$this->detailed_log[$line_number]["Message"] = "Skipped, Date format provided is wrong. Correct date format is 'YYYY-MM-DD' ";
					$this->detailed_log[$line_number]['state'] = 'Skipped';
				}	
				else{
					$data_array['post_date'] = current_time('Y-m-d H:i:s');
				}
			}									
		} 
		else {				
			//check the date format as 18/05/2022 (valid)
			$data_array['post_date'] = str_replace('/', '-', $data_array['post_date']);
		
			if(!strtotime( $data_array['post_date'])){						
				//check the date format as mm-dd-yyyy (valid)
				$data_array['post_date'] = str_replace(array('.','-'), '/', $data_array['post_date']);
				
				if(!strtotime($data_array['post_date'])){							
					//Wrong format (Not valid date)		
					$this->detailed_log[$line_number]["Message"] = "Skipped, Date format provided is wrong. Correct date format is 'YYYY-MM-DD' ";
					$this->detailed_log[$line_number]['state'] = 'Skipped';					
				}
				else {
					$data_array['post_date'] = date( 'Y-m-d H:i:s', strtotime( $data_array['post_date'] ) );
				}								
			}
			else {					
				//Valid date
				$data_array['post_date'] = date( 'Y-m-d H:i:s', strtotime( $data_array['post_date'] ) );
			}
		}
	}		
	return $data_array;
}

function get_matching_posts_by_category($helpers_instance, $post_cat_list, $categoryList ,$header_array, $value_array, $import_type, $import_as, $wpdb,$get_result,$mode) {
	// Fetch category values
	$post_cat_values = $helpers_instance->get_header_values($post_cat_list, $header_array, $value_array);
	//product_category
	if (empty($post_cat_values['post_category']) && empty($post_cat_values['product_category']) ) {
		return []; // Return empty array if no categories are provided
	}else{
		$csv_categories_values = !empty($post_cat_values['post_category']) ? $post_cat_values['post_category'] : $post_cat_values['product_category'];
	}
	// Extract categories
	$post_category_list = [];
	foreach (explode(',', $csv_categories_values) as $category) {
		$post_category_list = array_merge($post_category_list, explode('>', $category));
	}

	// Get all category IDs
	$category_ids = CoreFieldsImport::$mappingInstance->get_category_ids_from_names($categoryList, $import_type);
	// Get category IDs for extracted categories
	$csv_category_ids = CoreFieldsImport::$mappingInstance->get_category_ids_from_names($post_category_list, $import_type);
	// Find the matching category IDs
	$matching_category_ids = array_intersect($csv_category_ids, $category_ids);
	if (empty($matching_category_ids)) {
		return false;
	}
	// Prepare placeholders for SQL IN clause
	if($mode == 'Insert'){
		return true;
	}else{
		$placeholders = implode(',', array_fill(0, count($matching_category_ids), '%d'));

		// Prepare the query
		$query = $wpdb->prepare(
			"SELECT DISTINCT p.ID FROM {$wpdb->prefix}posts p
			INNER JOIN {$wpdb->prefix}term_relationships tr ON p.ID = tr.object_id
			INNER JOIN {$wpdb->prefix}term_taxonomy tt ON tr.term_taxonomy_id = tt.term_taxonomy_id
			WHERE p.post_type = %s
			AND p.post_status != 'trash'
			AND tt.term_id IN ($placeholders)
			ORDER BY p.ID DESC",
			array_merge([$import_as], $matching_category_ids)
		);
	
		// Execute Query (fetch as objects)
		$get_result_ids = $wpdb->get_results($query);

		$get_result_ids_array = array_map(fn($obj) => $obj->ID, $get_result_ids);
		$get_result_array = array_map(fn($obj) => $obj->ID, $get_result);

		// Find the intersection
		$common_ids = array_intersect($get_result_array,$get_result_ids_array);
		$get_result = !empty($common_ids) ? true : false;
		return $get_result;
	}
}
}


